	#include <stdio.h>
	#include <stdarg.h>
	#include <stdlib.h>
	#include <unistd.h>
	#include <errno.h>
	#include <string.h>
	#include <netdb.h>
	#include <netinet/in.h>
	#include <netinet/tcp.h>
	#include <arpa/inet.h>

	#include <dirent.h>
	
	#include <sys/dir.h>
	#include <sys/stat.h>
	#include <sys/param.h>
	#include <sys/socket.h>
	#include <sys/types.h>
	#include <time.h>
	
	#include <pwd.h>
	#include <fcntl.h>

#define XLIB4_INCLUDE
#include </usr/X11R6/include/X11/Xlib.h>
#include <X11/Xatom.h>
/* siva
To view all the windows: xwininfo -all -root | grep -i "trader"
xev is a great utility to debug the messages going into or out of a window

Check these articles for more info on xlib programming
http://x.holovko.ru/Xlib/contents.html
http://www.freedesktop.org/standards/wm-spec/1.3/
http://www.tigr.net/afterstep/X/xlib/appendix/a.html

to compile to a.out:
gcc -lX11 -L/usr/X11R6/lib close_windows.c

to compile to close_windows with max optimization
gcc -O3  -lX11 -L/usr/X11R6/lib close_windows.c -o close_windows

to compile to close_windows:
gcc -lX11 -L/usr/X11R6/lib close_windows.c -o close_windows

use this for warnings
gcc -O3 -ggdb -Wall -lX11 -L/usr/X11R6/lib close_windows.c -o close_windows
*/

#define DEBUG 8
#define DPRINT(error_level,args) if (error_level <= DEBUG) {printf("%4d:",__LINE__), indent(error_level), printf args, printf("\n");}
#define B(error_level,args) if (error_level <= DEBUG)  {printf("%4d:", __LINE__), indent(error_level),printf("Begin "), printf(args), printf("\n");}
#define E(error_level,args) if (error_level <= DEBUG)  {printf("%4d:", __LINE__), indent(error_level), printf("End "), printf(args), printf("\n");}

inline void indent(int level)   {
	time_t curtime = time(NULL);
	char *datetime = (char *) calloc(20, sizeof(char));
	strftime(datetime,20,"%a%Y%m%d%H%M%S", localtime(&curtime));
	printf("%s:",datetime);
	free(datetime);
	while (level-- > 0) printf("%c",'.');
	}
#define	CLOSE_WINDOW_SERV_PORT	6003	/* port used by the close_windows.c tcp server program*/
/* This handler is enabled when we are checking
   to see if the -id the user specified is valid. */

/* ARGSUSED */
int bad_window_handler(disp, err)
    Display *disp;
    XErrorEvent *err;
{
    char badid[20];

    sprintf(badid, "0x%lx", err->resourceid);
    DPRINT(10,("No such window with id %s.", badid));
    return 0;
}
  

Window get_children (Display *dpy, Window window)
	{
	Window *children, dummy;
	unsigned int nchildren;
	int i;
	Window w=0;
	char *window_name;
	int     xerr;
	XEvent  xkey;
	XWindowAttributes win_attributes;
	XClientMessageEvent MyEvent;

	//char *data;
	unsigned char * window_data;
	int real_format, current_desktop = 0;
	Atom real_type;
	unsigned long items_read, items_left;
	Atom net_current_desktop;

int (*old_handler)();

	DPRINT(10,("Window id: 0x%lx", window));/* print id # in hex/dec */
	old_handler = XSetErrorHandler(bad_window_handler);

	//20040702XSync(dpy,0);
	if (window && XFetchName(dpy, window, &window_name))	{
		DPRINT(10,("Windows name: %s", window_name));
		if (0 == strcmp(window_name, "Trader Workstation") || 0 == strcmp(window_name, "IB Trader Workstation"))
			{
				DPRINT(10,("before XGetWindowAttributes"));
				if (!XGetWindowAttributes(dpy, window, &win_attributes)) {
						DPRINT(10,("0x%lx: %s: Can't get window attributes.\n",window,window_name));
						//printf("0x%lx: %s: Can't get window attributes.\n",window,window_name);
						XFree(window_name);
						return 2;// CHECK: Changed from 0, to remove / find out any lingering windows
						}
				DPRINT(10,("after XGetWindowAttributes"));

				// cannot have this as it is not letting "confirm order" windows work. Confirm windows can be of different size depending on ur order defaults or not
				/*if (301 != win_attributes.width	||	90 != win_attributes.height ||	 24 != win_attributes.depth){
					DPRINT(10,("Window id: 0x%lx, name: %s, Wrong window attributes, Received Width: %i, Expected width: 301, Received Height: %i, Expected height: 90, Received Depth: %i, Expected depth: 24", window, window_name, win_attributes.width, win_attributes.height, win_attributes.depth));
					XFree(window_name);
					return 2;// CHECK: Changed from 0, to remove / find out any lingering windows
					}*/


				if (win_attributes.map_state != IsViewable) 	{
					DPRINT(10,("before _NET_CURRENT_DESKTOP"));
					net_current_desktop = XInternAtom(dpy, "_NET_CURRENT_DESKTOP", False);
					
					DPRINT(10,("before XGetWindowProperty"));
					if (XGetWindowProperty(dpy, DefaultRootWindow(dpy), net_current_desktop, 0L, 1L, False, XA_CARDINAL, &real_type, &real_format, &items_read, &items_left, &window_data) == Success) {
						DPRINT(10,("items_read: %li", items_read));
						if (items_read >= 1) 		{
							current_desktop = window_data[0];
							DPRINT(10,("Current desktop: %i", window_data[0]));
							XFree(window_data);
							}
						}

					//Display *display = (Display *) Application-> Display;
					MyEvent.type = ClientMessage;
					MyEvent.window = window;
					MyEvent.format = 32;
					MyEvent.data.l[0] = current_desktop;//2; // Desktop No. 3
					DPRINT(10,("before _NET_WM_DESKTOP"));
					MyEvent.message_type = XInternAtom(dpy, "_NET_WM_DESKTOP", False);

					DPRINT(10,("before XSendEvent"));
					XSendEvent(dpy, DefaultRootWindow(dpy), False,
						SubstructureNotifyMask | SubstructureRedirectMask, (XEvent *) &MyEvent);	
					DPRINT(10,(": Map state is either IsUnMapped or IsUnviewable: %i", win_attributes.map_state)); 
					XSync(dpy,0);
					DPRINT(10,("before XGetWindowAttributes"));
					if (!XGetWindowAttributes(dpy, window, &win_attributes)) {
						DPRINT(10,("0x%lx: %s: Can't get window attributes.\n",window,window_name));
						//printf("0x%lx: %s: Can't get window attributes.\n",window,window_name);
						XFree(window_name);
						return 2;// CHECK: Changed from 0, to remove / find out any lingering windows
						}
					}//if (win_attributes.map_state != IsViewable) 	{


				if (win_attributes.map_state == IsViewable) 	{
					DPRINT(10,("before XRaiseWindow"));
					XRaiseWindow(dpy,window);
					DPRINT(10,("after XRaiseWindow"));
					//useless: XMapWindow(dpy,window);
					//XGrabPointer(dpy, window, True,  EnterWindowMask | ButtonPressMask | ButtonReleaseMask, GrabModeSync,  GrabModeSync, None, None, CurrentTime);
		    			//XSelectInput(dpy, window,ExposureMask | PointerMotionMask);
					//XSync(dpy,0);
					XSync(dpy,0);
					XFlush(dpy);
					DPRINT(1,(" 0x%lx: \"%s\"", window, window_name));/* print id # in hex/dec */
					DPRINT(1,("Found IB Trader Workstation.  Sending keypress event"));
					//http://x.holovko.ru/Xlib/contents.html
					//XWarpPointer(dpy, None, window, 0, 0, 0, 0, 10, 10 );//moves the focus to the IB window.. Will it be an annoyance??
					//Can use the above line or both the below lines. Tried with XGrabKeyboard and XGrabButton, but they did not work
					XGrabPointer(dpy, window, 1, ButtonPressMask| ButtonReleaseMask| EnterWindowMask| LeaveWindowMask| PointerMotionMask| PointerMotionHintMask| Button1MotionMask| Button2MotionMask| Button3MotionMask, GrabModeSync,GrabModeSync, window, None, CurrentTime);
					XSync(dpy,0);
					XFlush(dpy);					
					XSetInputFocus(dpy,window,RevertToParent,CurrentTime);
					XSync(dpy,0);
					XFlush(dpy);
					XGetInputFocus(dpy,&window,&i);

					//sleep(20);
					/*
					* Fill out event fields
					*/
					xkey.type = KeyPress;
					xkey.xkey.type = KeyPress;
					xkey.xkey.display = dpy;
					xkey.xkey.window = window;
					xkey.xkey.root = DefaultRootWindow(dpy);
					xkey.xkey.subwindow = None;
					xkey.xkey.state = 0;
					xkey.xkey.x = xkey.xkey.y = xkey.xkey.x_root = xkey.xkey.y_root = 0;
					xkey.xkey.same_screen = True;
					xkey.xkey.keycode = 36;//XKeysymToKeycode(display, keysym);

					//xkey.xkey.time += 2000;

					/*
					* Do it
					*/
					XSync(dpy,0);
					XFlush(dpy);
					sleep(1);
					DPRINT(10,("before XSendEvent"));
					if ((xerr = XSendEvent(dpy, window, 0, False, &xkey)) == 0) {
					//if ((xerr = XSendEvent(dpy, window, 1, ButtonReleaseMask, &xkey)) == 0) {
						printf("failed to send (return code %d).\n", xerr);
						exit(1);
						}
					DPRINT(1,("After XSendEvent: (return code %d).\n", xerr));
					XSync(dpy,0);
					XFlush(dpy);
					//DPRINT(10,("before XDestroyWindow"));
					XDestroyWindow(dpy, window); // to remove the window hanging around in xwininfo
					//XSync(dpy,0);
					XFree(window_name);
					return(1);
					}//if (win_attributes.map_state == IsViewable) 	{
				}//if (0 == strcmp(window_name, "Trader Workstation") || 0 == strcmp(window_name, "IB Trader Workstation"))	{
		}//if (window && XFetchName(dpy, window, &window_name))
	XFree(window_name);

	//20040702XSync(dpy,0);
	DPRINT(10,("before XGetWindowAttributes"));
	if (!XGetWindowAttributes(dpy, window, &win_attributes)) {
		DPRINT(10,("0x%lx: %s: Can't get window attributes.\n",window,window_name));
		//printf("0x%lx: %s: Can't get window attributes.\n",window,window_name);
		XFree(window_name);
		return 0;
		}
	DPRINT(10,("before XQueryTree"));
	if (!XQueryTree(dpy, window, &dummy, &dummy, &children, &nchildren))  return(0);

	for (i=0; i<nchildren; i++) {
		w = get_children(dpy, children[i]);
		if (1 == w) break;
		}

	if (children) XFree ((char *)children);

	return(w);
	}

int close_windows (int just_checking)
	{
	Window top;//, window;
	int ib_window_found = 0;
	//char *window_name;
	Display *dpy;
	int time_spent_for_finding_window = 0;

	B(10,"send_close_window_message");
	//printf("Program started\n");
	//printf("before XOpenDisplay\n");
	dpy = XOpenDisplay(NULL);
	if (dpy == NULL)  fprintf (stderr, "unable to open display\n");

	XSynchronize(dpy, 1);
	top = DefaultRootWindow(dpy);
	DPRINT(10,("before get_children"));
	ib_window_found = get_children (dpy, top);
	if (1 != ib_window_found) ib_window_found = just_checking;
	while (1 != ib_window_found && time_spent_for_finding_window < 600) 	{//try for 10 mins after each signal received
		DPRINT(1,("Could not find IB Trader workstation. Trying again.."));
		if (1 != ib_window_found) 	ib_window_found = get_children (dpy, top);
		time_spent_for_finding_window += 2;
		sleep(2);
		}
		//Display_Tree_Info(dpy, top);
		//printf("\tSleeping for 2 secs\n");
		//sleep(2);
//		}
	XFlush(dpy);
	//printf("Before closing display\n");
	XSynchronize(dpy, 0);
	XCloseDisplay(dpy);
	E(10,"send_close_window_message");
	return ib_window_found;
	}

int
main()					/* simple TCP server */
{
	struct sockaddr_in	serv, cli;
	char				request[20];//, reply[REPLY];
	int				listenfd, sockfd, n, clilen;
	//struct linger		linger_not;

	if ( (listenfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)	{DPRINT(1, ("%s", "socket error"));}

	memset(&serv, 0, sizeof(serv));
	serv.sin_family      = AF_INET;
	serv.sin_addr.s_addr = inet_addr("127.0.0.1");
	serv.sin_port        = htons(CLOSE_WINDOW_SERV_PORT);

// Set the SO_REUSEADDR options - Richard Stevens Vol 1 : Pg 194
	n = 1;
	if (0 == setsockopt(listenfd, SOL_SOCKET, SO_REUSEADDR,&n, sizeof(n))) {DPRINT(1, ("%s", "set SO_REUSEADDR"));} else {{DPRINT(1, ("%s", "Could NOT set SO_REUSEADDR"));}}
// Removing the linger option
// Set the SO_LINGER options - Richard Stevens Vol 1 : Pg 187
//	linger_not.l_onoff = 1;
//	linger_not.l_linger = 0;
//	if (0 == setsockopt(listenfd, SOL_SOCKET, SO_LINGER,&linger_not, sizeof(linger_not))) {DPRINT(1, ("%s", "set SO_LINGER"));} else {{DPRINT(1, ("%s", "Could NOT set SO_LINGER"));}}
	close_windows(1);// check for open windows before starting up
	while (1)	{
		if (bind(listenfd, (struct sockaddr *) &serv, sizeof(serv)) < 0)	{
			DPRINT(1, ("%s", "Could not bind to close_windows socket at 127.0.0.1:6003"));
			sleep(10);
			continue;
			}

		if (listen(listenfd, SOMAXCONN) < 0)		{DPRINT(1, ("%s", "Could not listen on close_windows socket at 127.0.0.1:6003"));}
	
		for ( ; ; ) {
			clilen = sizeof(cli);
			if ( (sockfd = accept(listenfd, (struct sockaddr *) &cli, &clilen)) < 0) {DPRINT(1, ("%s", "Could not accept on close_windows socket at 127.0.0.1:6003")); break;}
	
			if ( (n=read(sockfd, request, 20)) < 0) {DPRINT(1, ("%s", "Could not read on close_windows socket at 127.0.0.1:6003")); break;}

			if (0 != strncmp(request,"CLOSE_WINDOW",12)) 
				{DPRINT(1, ("CLOSE_WINDOW not received. Received %s\n", request));
				continue;}

			DPRINT(1, ("Received %s\n", request));
			/* process "n" bytes of request[] and create reply[] ... */
	
			//strcpy(reply, "u fuck off\n");
			//if (write(sockfd, reply, REPLY) != REPLY)	printf("write error");
			/*  close socket immediately */
			if (shutdown(sockfd, SHUT_RDWR) < 0) {DPRINT(1, ("%s", "Could not shutdown close_windows socket"));}
			close(sockfd);
			close_windows(0);
			close_windows(1);//just checking if the job has been done
			}

		if (shutdown(listenfd, SHUT_RDWR) < 0) {DPRINT(1, ("%s", "Could not shutdown close_windows socket"));}
		close(listenfd);
		}//while (1)	{
}
